#
# Code example demonstrating use of lists
#
# author: David Mathias
#

# list creation
L1 = ['Blue Hens', 'Hoosiers', 'Buckeyes', 'Mocs', 'Eagles']
L2 = [12, 87, 92, 31, 57, 20, 44, 6, 33, 22, 40]
L3 = ['Blue Hens', 'Hoosiers', 'Buckeyes', 'Mocs', 'Eagles']
L4 = ['Lions', 'Tigers', 'Bears']

print()
print('List initial values:')
print("   L1: {}".format(L1))
print("   L2: {}".format(L2))
print("   L3: {}".format(L3))
print("   L4: {}".format(L4))
print()

# add elements to a list using append
print('Adding elements to a list:')
L1.append("Bears")
print("   L1.append('Bears'): {}".format(L1))
print()

# add elements to a list using insert
L1.insert(2, 'Banana Slugs')
print("   L1.insert(2, 'Banana Slugs')".format(L1))
print()
L1.insert(len(L1), 'Sea Sponges')
print("   L1.insert(len(L1), 'Sea Sponges')".format(L1))
print()


# remove elements from a list
# pop removes the last element and returns it
print('Remove elements from a list:')
elt = L1.pop()
print('   L1.pop(): {}  {}'.format(elt, L1))
print()

# del deletes the specified element but does not return it
del L1[1]
print('   del L1[1]: {}'.format(L1))
print()

# remove element based on it's value.  removes only one occurrence.
L2.remove(31)
print('   L2.remove(31): {}'.format(L2))
print()

# remove element based on it's value.  removes only one occurrence.
L2.remove(min(L2))
print('   L2.remove(min(L2)): {}'.format(min(L2)))
print()

# remove gives an error if the specified element isn't there
# so check first
print('Remove 8 from L2 only if it is in the list:')
if L2.count(8) > 0:
    val = L2.remove(8)
    print('   val = {}'.format(val))
else:
    print('   8 not in L2')
print()


# combine lists
print('   Combine lists:')
# + concatenates lists but doesn't change them
print('   L1 + L2: {}'.format(L1 + L2))
print()
print('   L1 after L1 + L2: {}'.format(L1))
print()
print('   L2 after L1 + L2: {}'.format(L2))
print()

# extend concatenates, changing L1
L1.extend(L4)
print('   L1 after L1.extend(L4): {}'.format(L1))
print()
print('   L4 after L1.extend(L4): {}'.format(L4))
print()


# ordering listS
print('Ordering lists:')
# sort sorts in lexicographic order, changing the list
L1.sort()
print('   L1.sort(): {}'.format(L1))
print()

# passing the reverse flag sorts in reverse lexicographic order
L1.sort(reverse=True)
print('   L1.sort(reverse=True): {}'.format(L1))
print()

# reverse doesn't sort the list, it simply reverses the order
L2.reverse()
print('   L2.reverse(): {}'.format(L2))
print()

# key allows you to use a function to determine the order
L3.sort(key=lambda e: e[2])
print('   L3.sort(lambda e: e[2]):  {}'.format(L3))
print()

# why doesn't this work?
L1[1:4].sort()
print('   Why doesnt this work?:')
print('   L1[1:4].sort(): {}'.format(L1))
print()
print('   and this doesnt either?:')
print('   L1[1:4].sort(): {}'.format(L1[1:4].sort()))
print()
print('   But this does?:')
print('   sorted(L1[1:4]): {}'.format(sorted(L1[1:4])))
print()

# sorting part of a list
print("   L1: {}".format(L1))
L1 = L1[0:1] + sorted(L1[1:4]) + L1[4:]
print('   L1[0:1] + sorted(L1[1:4]) + L1[4:]: ')
print('     {}'.format(L1))
print()
